Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::X509_Object Class Referenceabstract

`#include <x509_obj.h>`

Inheritance diagram for Botan::X509_Object:

## Public Member Functions
std::vector< uint8_t > | BER_encode () const
bool | check_signature (const Public_Key &key) const
bool | check_signature (const Public_Key *key) const
void | decode_from (class BER_Decoder &from) override
void | encode_into (class DER_Encoder &to) const override
std::string | hash_used_for_signature () const
X509_Object & | operator= (const X509_Object &)=default
std::string | PEM_encode () const
std::vector< uint8_t > | signature () const
AlgorithmIdentifier | signature_algorithm () const
std::vector< uint8_t > | tbs_data () const
| X509_Object (const X509_Object &)=default
virtual | ~X509_Object ()=default

## Static Public Member Functions
static std::vector< uint8_t > | make_signed (class PK_Signer *signer, RandomNumberGenerator &rng, const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &tbs)

## Protected Member Functions
void | do_decode ()
| X509_Object (DataSource &src, const std::string &pem_labels)
| X509_Object (const std::vector< uint8_t > &vec, const std::string &labels)
| X509_Object ()=default

## Protected Attributes
std::vector< uint8_t > | m_sig
AlgorithmIdentifier | m_sig_algo
std::vector< uint8_t > | m_tbs_bits

## Detailed Description

This class represents abstract X.509 signed objects as in the X.500 SIGNED macro

Definition at line 22 of file x509_obj.h.

## Constructor & Destructor Documentation

Botan::X509_Object::X509_Object | ( | const X509_Object & |  | ) |
| default

virtual Botan::X509_Object::~X509_Object | ( |  | ) |
| virtual default

Botan::X509_Object::X509_Object | ( | DataSource & | src,
|  | const std::string & | pem_labels
| ) |  |
| protected

Definition at line 23 of file x509_obj.cpp.

24 {
25 init(stream, labels);
26 }

Botan::X509_Object::X509_Object | ( | const std::vector< uint8_t > & | vec,
|  | const std::string & | labels
| ) |  |
| protected

Definition at line 42 of file x509_obj.cpp.

43 {
44 DataSource_Memory stream(vec.data(), vec.size());
45 init(stream, labels);
46 }

Botan::X509_Object::X509_Object | ( |  | ) |
| protected default

## Member Function Documentation

std::vector< uint8_t > Botan::X509_Object::BER_encode | ( |  | ) | const

Returns
  BER encoding of this

Definition at line 114 of file x509_obj.cpp.

References encode_into(), and Botan::DER_Encoder::get_contents_unlocked().

Referenced by Botan::X509_Certificate::fingerprint(), and PEM_encode().

115 {
116 DER_Encoder der;
117 encode_into(der);
118 return der.get_contents_unlocked();
119 }
Botan::X509_Object::encode_into
void encode_into(class DER_Encoder &to) const override
Definition: x509_obj.cpp:86

bool Botan::X509_Object::check_signature | ( | const Public_Key & | key | ) | const

Check the signature on this data

Parameters

  key | the public key purportedly used to sign this data

Returns
  true if the signature is valid, otherwise false

Definition at line 188 of file x509_obj.cpp.

References Botan::Public_Key::algo_name(), Botan::DER_SEQUENCE, Botan::IEEE_1363, Botan::OIDS::lookup(), m_sig_algo, Botan::Public_Key::message_parts(), Botan::AlgorithmIdentifier::oid, signature(), Botan::split_on(), tbs_data(), and Botan::PK_Verifier::verify_message().

Referenced by check_signature().

189 {
190 try {
191 std::vector<std::string> sig_info =
192 split_on(OIDS::lookup(m_sig_algo.oid), '/');
193
194 if(sig_info.size() != 2 || sig_info[0] != pub_key.algo_name())
195 return false;
196
197 std::string padding = sig_info[1];
198 Signature_Format format =
199 (pub_key.message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
200
201 PK_Verifier verifier(pub_key, padding, format);
202
203 return verifier.verify_message(tbs_data(), signature());
204 }
205 catch(std::exception&)
206 {
207 return false;
208 }
209 }
Botan::X509_Object::m_sig_algo
AlgorithmIdentifier m_sig_algo
Definition: x509_obj.h:109
Botan::Signature_Format
Signature_Format
Definition: pubkey.h:29
Botan::split_on
std::vector< std::string > split_on(const std::string &str, char delim)
Definition: parsing.cpp:138
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18
Botan::AlgorithmIdentifier::oid
OID oid
Definition: alg_id.h:36
Botan::X509_Object::signature
std::vector< uint8_t > signature() const
Definition: x509_obj.cpp:140
Botan::IEEE_1363
Definition: pubkey.h:29
Botan::X509_Object::tbs_data
std::vector< uint8_t > tbs_data() const
Definition: x509_obj.cpp:132
Botan::DER_SEQUENCE
Definition: pubkey.h:29

bool Botan::X509_Object::check_signature | ( | const Public_Key * | key | ) | const

Check the signature on this data

Parameters

  key | the public key purportedly used to sign this data the pointer will be deleted after use

Returns
  true if the signature is valid, otherwise false

Definition at line 177 of file x509_obj.cpp.

References check_signature().

178 {
179 if(!pub_key)
180 throw Exception("No key provided for " + m_PEM_label_pref + " signature check");
181 std::unique_ptr<const Public_Key> key(pub_key);
182 return check_signature(*key);
183 }
Botan::X509_Object::check_signature
bool check_signature(const Public_Key &key) const
Definition: x509_obj.cpp:188

void Botan::X509_Object::decode_from | ( | class BER_Decoder & | from | ) |
| override virtual

Decode a BER encoded X509_Object See ASN1_Object::decode_from()

Implements Botan::ASN1_Object.

Definition at line 100 of file x509_obj.cpp.

References Botan::BIT_STRING, Botan::BER_Decoder::decode(), Botan::BER_Decoder::end_cons(), m_sig, m_sig_algo, m_tbs_bits, Botan::BER_Decoder::raw_bytes(), Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

101 {
102 from.start_cons(SEQUENCE)
103 .start_cons(SEQUENCE)
104 .raw_bytes(m_tbs_bits)
105 .end_cons()
106 .decode(m_sig_algo)
107 .decode(m_sig, BIT_STRING)
108 .end_cons();
109 }
Botan::X509_Object::m_sig_algo
AlgorithmIdentifier m_sig_algo
Definition: x509_obj.h:109
Botan::X509_Object::m_tbs_bits
std::vector< uint8_t > m_tbs_bits
Definition: x509_obj.h:110
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34
Botan::X509_Object::m_sig
std::vector< uint8_t > m_sig
Definition: x509_obj.h:110

void Botan::X509_Object::do_decode | ( |  | ) |
| protected

Definition at line 231 of file x509_obj.cpp.

References Botan::Exception::what().

Referenced by Botan::PKCS10_Request::PKCS10_Request(), Botan::X509_Certificate::X509_Certificate(), and Botan::X509_CRL::X509_CRL().

232 {
233 try {
234 force_decode();
235 }
236 catch(Decoding_Error& e)
237 {
238 throw Decoding_Error(m_PEM_label_pref + " decoding failed (" +
239 e.what() + ")");
240 }
241 catch(Invalid_Argument& e)
242 {
243 throw Decoding_Error(m_PEM_label_pref + " decoding failed (" +
244 e.what() + ")");
245 }
246 }

void Botan::X509_Object::encode_into | ( | class DER_Encoder & | to | ) | const
| override virtual

DER encode an X509_Object See ASN1_Object::encode_into()

Implements Botan::ASN1_Object.

Definition at line 86 of file x509_obj.cpp.

References Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), m_sig, m_sig_algo, m_tbs_bits, Botan::DER_Encoder::raw_bytes(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by BER_encode(), and Botan::Certificate_Store_In_SQL::insert_cert().

87 {
88 to.start_cons(SEQUENCE)
89 .start_cons(SEQUENCE)
90 .raw_bytes(m_tbs_bits)
91 .end_cons()
92 .encode(m_sig_algo)
93 .encode(m_sig, BIT_STRING)
94 .end_cons();
95 }
Botan::X509_Object::m_sig_algo
AlgorithmIdentifier m_sig_algo
Definition: x509_obj.h:109
Botan::X509_Object::m_tbs_bits
std::vector< uint8_t > m_tbs_bits
Definition: x509_obj.h:110
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34
Botan::X509_Object::m_sig
std::vector< uint8_t > m_sig
Definition: x509_obj.h:110

std::string Botan::X509_Object::hash_used_for_signature | ( |  | ) | const

Returns
  hash algorithm that was used to generate signature

Definition at line 156 of file x509_obj.cpp.

References Botan::OID::as_string(), Botan::OIDS::lookup(), m_sig_algo, Botan::AlgorithmIdentifier::oid, Botan::parse_algorithm_name(), and Botan::split_on().

157 {
158 std::vector<std::string> sig_info =
159 split_on(OIDS::lookup(m_sig_algo.oid), '/');
160
161 if(sig_info.size() != 2)
162 throw Internal_Error("Invalid name format found for " +
163 m_sig_algo.oid.as_string());
164
165 std::vector<std::string> pad_and_hash =
166 parse_algorithm_name(sig_info[1]);
167
168 if(pad_and_hash.size() != 2)
169 throw Internal_Error("Invalid name format " + sig_info[1]);
170
171 return pad_and_hash[1];
172 }
Botan::parse_algorithm_name
std::vector< std::string > parse_algorithm_name(const std::string &namex)
Definition: parsing.cpp:85
Botan::X509_Object::m_sig_algo
AlgorithmIdentifier m_sig_algo
Definition: x509_obj.h:109
Botan::split_on
std::vector< std::string > split_on(const std::string &str, char delim)
Definition: parsing.cpp:138
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18
Botan::AlgorithmIdentifier::oid
OID oid
Definition: alg_id.h:36
Botan::OID::as_string
std::string as_string() const
Definition: asn1_oid.cpp:50

std::vector< uint8_t > Botan::X509_Object::make_signed | ( | class PK_Signer * | signer,
|  | RandomNumberGenerator & | rng,
|  | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | tbs
| ) |  |
| static

Create a signed X509 object.

Parameters

  signer | the signer used to sign the object
  rng | the random number generator to use
  alg_id | the algorithm identifier of the signature scheme
  tbs | the tbs bits to be signed

Returns
  signed X509 object

Definition at line 214 of file x509_obj.cpp.

References Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::get_contents_unlocked(), Botan::DER_Encoder::raw_bytes(), Botan::SEQUENCE, Botan::PK_Signer::sign_message(), and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::create_cert_req(), and Botan::X509_CA::make_cert().

218 {
219 return DER_Encoder()
220 .start_cons(SEQUENCE)
221 .raw_bytes(tbs_bits)
222 .encode(algo)
223 .encode(signer->sign_message(tbs_bits, rng), BIT_STRING)
224 .end_cons()
225 .get_contents_unlocked();
226 }
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

X509_Object& Botan::X509_Object::operator= | ( | const X509_Object & |  | ) |
| default

std::string Botan::X509_Object::PEM_encode | ( |  | ) | const

Returns
  PEM encoding of this

Definition at line 124 of file x509_obj.cpp.

References BER_encode(), and Botan::PEM_Code::encode().

125 {
126 return PEM_Code::encode(BER_encode(), m_PEM_label_pref);
127 }
Botan::X509_Object::BER_encode
std::vector< uint8_t > BER_encode() const
Definition: x509_obj.cpp:114
Botan::PEM_Code::encode
std::string encode(const uint8_t der[], size_t length, const std::string &label, size_t width)
Definition: pem.cpp:43

std::vector< uint8_t > Botan::X509_Object::signature | ( |  | ) | const

Returns
  signature on tbs_data()

Definition at line 140 of file x509_obj.cpp.

References m_sig.

Referenced by check_signature().

141 {
142 return m_sig;
143 }
Botan::X509_Object::m_sig
std::vector< uint8_t > m_sig
Definition: x509_obj.h:110

AlgorithmIdentifier Botan::X509_Object::signature_algorithm | ( |  | ) | const

Returns
  signature algorithm that was used to generate signature

Definition at line 148 of file x509_obj.cpp.

References m_sig_algo.

Referenced by Botan::X509_Certificate::to_string().

149 {
150 return m_sig_algo;
151 }
Botan::X509_Object::m_sig_algo
AlgorithmIdentifier m_sig_algo
Definition: x509_obj.h:109

std::vector< uint8_t > Botan::X509_Object::tbs_data | ( |  | ) | const

The underlying data that is to be or was signed

Returns
  data that is or was signed

Definition at line 132 of file x509_obj.cpp.

References m_tbs_bits, and Botan::ASN1::put_in_sequence().

Referenced by check_signature().

133 {
134 return ASN1::put_in_sequence(m_tbs_bits);
135 }
Botan::X509_Object::m_tbs_bits
std::vector< uint8_t > m_tbs_bits
Definition: x509_obj.h:110
Botan::ASN1::put_in_sequence
std::vector< uint8_t > put_in_sequence(const std::vector< uint8_t > &contents)
Definition: asn1_obj.cpp:35

## Member Data Documentation

std::vector<uint8_t> Botan::X509_Object::m_sig
| protected

Definition at line 110 of file x509_obj.h.

Referenced by decode_from(), encode_into(), Botan::X509_Certificate::operator<(), Botan::X509_Certificate::operator==(), and signature().

AlgorithmIdentifier Botan::X509_Object::m_sig_algo
| protected

Definition at line 109 of file x509_obj.h.

Referenced by check_signature(), decode_from(), encode_into(), hash_used_for_signature(), Botan::X509_Certificate::operator==(), and signature_algorithm().

std::vector<uint8_t> Botan::X509_Object::m_tbs_bits
| protected

Definition at line 110 of file x509_obj.h.

Referenced by decode_from(), encode_into(), Botan::X509_Certificate::operator<(), and tbs_data().

The documentation for this class was generated from the following files:

- src/lib/x509/x509_obj.h
- src/lib/x509/x509_obj.cpp